Imports System.IO
Imports System.Data
Imports MySql.Data
Imports MySql.Data.MySqlClient

Partial Class category
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        If Page.IsPostBack = False Then
            HiddenPageName.Value = Request.QueryString("PageName")

            ' When the page loads we select data from the categoryTbl table according to the PageName parameter the we
            ' get from the url by interpret the url in the web.config file.

            Try
                Dim ConnString As String = ConfigurationManager.ConnectionStrings("ConnectionString").ToString()
                Dim sql As String = "SELECT * FROM categoryTbl WHERE PageName = @PageName"

                ' The Using block is used to call dispose (close) automatically even if there are an exception.
                Using cn As New MySqlConnection(ConnString), _
                      cmd As New MySqlCommand(sql, cn)
                    cmd.Parameters.Add("@PageName", MySqlDbType.VarChar, 100).Value = HiddenPageName.Value

                    cn.Open()
                    ' The Using block is used to call dispose (close) automatically even if there are an exception.
                    Using reader As MySqlDataReader = cmd.ExecuteReader(CommandBehavior.SingleRow)
                        While reader.Read()
                            HiddenCategoryID.Value = reader("Id").ToString()
                            HeadLiteral.Text = reader("Name").ToString()
                            ltTitle.Text = reader("MetaTitle").ToString()
                            ltDescription.Text = "<meta name=""description"" content=""" & reader("MetaDescription").ToString() & """/>"
                            ltKeywords.Text = "<meta name=""keywords"" content=""" & reader("MetaKeywords").ToString() & """/>"
                            ltRobots.Text = "<meta name=""robots"" content=""noindex, follow""/>"
                            ltCanonical.Text = "<link rel=""canonical"" href=""" & "http://www.mypage.com/category/" & HiddenPageName.Value & ".aspx" & """/>"
                        End While
                    End Using

                End Using
            Catch ex As Exception
                Response.Write(ex.Message)
            End Try

            ' This word below calles the subroutin "BindData" that is used to fill the repeater control with content.
            
            BindData()

        End If
    End Sub
    Protected Sub BindData()

        ' We select data from the contentTbl according to the selected CategoryID in the pageload event.
        ' The selected data is used to bind data to a repeater.

        Try
            Dim ConnString As String = ConfigurationManager.ConnectionStrings("ConnectionString").ToString()
            Dim sql As String = "SELECT * FROM contentTbl WHERE CategoryID = @CategoryID ORDER BY Name ASC"

            ' The Using block is used to call dispose (close) automatically even if there are an exception.
            Using cn As New MySqlConnection(ConnString), _
                  sad As New MySqlDataAdapter(), _
                  cmd As New MySqlCommand(sql, cn)
                cmd.Parameters.Add("@CategoryId", MySqlDbType.Int32).Value = HiddenCategoryID.Value

                cn.Open()
                sad.SelectCommand = cmd

                ' The Using block is used to call dispose (close) automatically even if there are an exception.
                Using dt As DataTable = New DataTable()
                    sad.Fill(dt)

                    ' Populate the repeater control with the datatable 
                    Dim objPds As PagedDataSource = New PagedDataSource()
                    objPds.DataSource = dt.DefaultView

                    ' Indicate that the data should be paged 
                    objPds.AllowPaging = True

                    ' Set the pagesize 
                    objPds.PageSize = 10

                    ' Print out pageinformation with navigationlinks
                    Dim curpage As Int32

                    If Not IsNothing(Request.QueryString("Page")) Then
                        curpage = Convert.ToInt32(Request.QueryString("Page"))
                    Else
                        curpage = 1
                    End If

                    objPds.CurrentPageIndex = curpage - 1

                    lblCurrentPage.Text = "| Page: " + curpage.ToString() + " av " + objPds.PageCount.ToString() + " |"

                    If Not objPds.IsFirstPage Then
                        lnkPrev.Visible = True
                        lnkPrev.NavigateUrl = GeneratePageURL(HiddenPageName.Value) + _
                                                       "page-" + CStr(curpage - 1) + ".aspx"
                    End If

                    If Not objPds.IsLastPage Then
                        lnkNext.Visible = True
                        lnkNext.NavigateUrl = GeneratePageURL(HiddenPageName.Value) + _
                                                       "page-" + CStr(curpage + 1) + ".aspx"
                    End If

                    ContentListRepeater.DataSource = objPds
                    ContentListRepeater.DataBind()

                End Using
            End Using
        Catch ex As Exception
            Response.Write(ex.Message)
        End Try
    End Sub
    Public Function GenerateURL(ByVal Contentname As Object) As String

        'Create SEO Friendly URL for each content link
        Dim strConUrl As String = "~/article/" & Contentname & ".aspx"

        Return strConUrl
    End Function
    Public Function GeneratePageURL(ByVal Catname As Object) As String

        ' Create SEO Friendly URL for each category page
        Dim strCatUrl As String = "~/category/" & Catname & "/"

        Return strCatUrl
    End Function
End Class
